// Nancy Montanez
// Written: October 14, 2000
// Modified: November 22, 2000 -- Re-Nancified the code and updated error
//			messages
// Modified Again: Nov 26, 2000 -- More error checking
// Modified Once again: Dec 2, 2000 -- Final version, with refined code and error checking 
// (Are you happy now, Alex? )

#define _WIN32_WINNT 0x0400
#define WINVER 0x0400

#include <windows.h>
#include <ws2tcpip.h>

#include "dmz_net.h"
#include "dmz_net_internal.h"

//-----------------------------------------------
//Function: dmz_send
//
int dmz_send_msg(void *mesg, int size, int connect_id)
{
	
	int bytes_sent = 0;

	if (!init_done)
		return DMZ_NET_NOT_INIT;

	if ( (connect_id < 0) || (connect_id > MAX_CONNECT) || (mesg == NULL) || (size <= 0))
		return DMZ_NET_INVALID_PARAM;
	
	bytes_sent = send(sockets[connect_id].s, (const char*) mesg, size, 0);

	if (bytes_sent < 0)
		return DMZ_NET_SEND_ERROR;

	return bytes_sent;
}

//---------------------------------------------------
//Function: dmz_receive

int dmz_recv_msg(void *mesg, int size, int connect_id)
{
	
	int bytes_recv = 0, WSAErr;

	if (!init_done)
		return DMZ_NET_NOT_INIT;

	if ( (connect_id < 0) || (connect_id > MAX_CONNECT) || (mesg == NULL) || (size <= 0) )
		return DMZ_NET_INVALID_PARAM;
	
	bytes_recv = recv(sockets[connect_id].s, (char *) mesg, size, 0);

	if(bytes_recv == SOCKET_ERROR)
	{
		WSAErr = WSAGetLastError();

		if(WSAErr != WSAEWOULDBLOCK)
			return DMZ_NET_RECV_ERROR;
		else
			return DMZ_NET_TRY_AGAIN;

	}

	/*if(bytes_recv  == WSAEWOULDBLOCK)
	{
		return DMZ_NET_TRY_AGAIN;
	}
	*/
	//if(bytes_recv < 0)
	//	return DMZ_NET_RECV_ERROR;
	/*else
	 if (bytes_recv == 0)
		return DMZ_NET_TRY_AGAIN;
	*/
	
	return bytes_recv;
}
//-------------------------- End of sendrecv.cpp --------------------------------------------