/*	File:	init.cpp
	Author:	Alex Fedosov
	Date:	October 9, 2000
	Description:	DMZ sound implementation, this is the main DLL file
*/

#include <windows.h>
#include <dsound.h>

#include "dmz_snd.h"
#include "dmz_snd_internal.h"

LPDIRECTSOUND lpds = NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// This is an example of an exported variable
DMZ_SOUND_API int nCore=0;

// This is an example of an exported function.
DMZ_SOUND_API int fnCore(void)
{
	return 42;
}

int dmz_snd_init(void* hwnd)
{
	int i;

	if (lpds != NULL) return DMZ_SND_ALREADY_INIT;

	for (i = 0; i < MAXSOUNDS; i++)
	{
		lpsounds[i] = NULL;
		current_volume[i] = 0;
		current_pan[i] = 0;
	}

	// create the main DirectSound object
	if (DirectSoundCreate(NULL, &lpds, NULL) != DS_OK)
		return DMZ_SND_DS_ERROR;

	// set the cooperation level
	if (lpds->SetCooperativeLevel((HWND) hwnd, DSSCL_NORMAL) != DS_OK)
		return DMZ_SND_DS_ERROR;

	return DMZ_SND_SUCCESS;
}

void dmz_snd_kill(void)
{
	int i;
	
	for (i = 0; i < MAXSOUNDS; i++)
	{
		DXSAFERELEASE(lpsounds[i]);
	}

	DXSAFERELEASE(lpds);
}
